;	
;	framdmga.s
;
;	P/ECE DMG-CPU Emulator
;
;	CLiP - Common Library for P/ECE
;	Copyright (C) 2001-2004 Naoyuki Sawa
;
;	* Thu Jan 15 20:09:00 JST 2004 Naoyuki Sawa
;	- 쐬JnB
;
#include "clipdmga.h"
#ifdef  DMG_ASM

	.code
	.align 1

;****************************************************************************
;
;****************************************************************************

;
;	DMG\
;
;===== WX^ =====
#define F	 0
#define A	 1
#define C	 2
#define B	 3
#define E	 4
#define D	 5
#define L	 6
#define H	 7
#define AF	 0
#define BC	 2
#define DE	 4
#define HL	 6
#define SP	 8
#define PC	10
;=====  =====
#define IME	12
#define HALT	13
#define CYCLE	20
;===== O֐ =====
#define READ	24
#define WRITE	28

;****************************************************************************
;
;****************************************************************************

	.global dmg_run
dmg_run:
	pushn %r3
	xsub %sp, %sp, 4
	;
	ld.w %r0, %r12			; dmg
	xld.w %r3, [%r0+READ]		; dmg->read
	xld.w [%r0+CYCLE], %r13		; CYCLE
	xcmp %r13, 0			; if(CYCLE <= 0) break
	xjrle dmg_run_EXIT
	;
dmg_run_LOOP:
	xld.ub %r10, [%r0+HALT]		; if(HALT) break
	xld.uh %r1, [%r0+PC]		; PC *anti-interlock*
	xcmp %r10, 0
	xjrne dmg_run_EXIT
	;
	ld.w %r12, %r0			; code = dmg->read(dmg, PC++)
	ld.uh %r13, %r1
	call.d %r3
	add %r1, 1			; *delay*
	ld.w %r13, %r10
	;
	xld.w %r2, dmg_op_table		; op = &dmg_op_table[code]
	xsll %r10, 3
	add %r2, %r10
	;
	xld.ub %r10, [%r2+4]		; argc == 0 ?
	xcmp %r10, 0	
	xjreq dmg_run_L10
	xld.b [%sp+0], %r13		; (save code)
	;
	ld.w %r12, %r0			; LO(arg) = dmg->read(dmg, PC++)
	ld.uh %r13, %r1
	call.d %r3
	add %r1, 1			; *delay*
	ld.w %r14, %r10
	;
	xld.ub %r10, [%r2+4]		; argc == 1 ?
	xcmp %r10, 1	
	xjreq dmg_run_L20
	xld.b [%sp+1], %r14		; (save LO(arg))
	;
	ld.w %r12, %r0			; HI(arg) = dmg->read(dmg, PC++)
	ld.w %r13, %r1
	call.d %r3
	add %r1, 1			; *delay*
	;
	xld.ub %r14, [%sp+1]		; (restore LO(arg))
	xsll %r10, 8			; *anti-interlock*
	or %r14, %r10			; arg = LO(arg) | HI(arg) << 8
dmg_run_L20:
	xld.ub %r13, [%sp+0]		; (restore code)
dmg_run_L10:
	;
	xld.w %r10, [%r2+0]		; op->proc(dmg, code, arg1, arg2)
	xld.h [%r0+PC], %r1		; PC *anti-interlock*
	call.d %r10
	ld.w %r12, %r0			; *delay*
	;
	xld.w %r10, [%r0+CYCLE]		; CYCLE -= op->cycle
	xld.ub %r11, [%r2+5]
	sub %r10, %r11
	xld.w [%r0+CYCLE], %r10
	xjrgt dmg_run_LOOP		; if(CYCLE <= 0) break
dmg_run_EXIT:
	;
	xadd %sp, %sp, 4
	popn %r3
	ret

	.global dmgop_CB
dmgop_CB:
	pushn %r2
	;
	ld.w %r0, %r12			; dmg
	xld.uh %r1, [%r0+PC]		; PC
	;
	xld.w %r11, [%r0+READ]		; code = dmg->read(dmg, PC++)
	ld.w %r12, %r0
	ld.uh %r13, %r1
	call.d %r11
	add %r1, 1			; *delay*
	ld.w %r13, %r10
	;
	xld.w %r2, dmg_op_table_CB	; op = &dmg_op_table_CB[code]
	xsll %r10, 3
	add %r2, %r10
	;
	xld.w %r10, [%r2+0]		; op->proc(dmg, code, arg1, arg2)
	xld.h [%r0+PC], %r1		; PC *anti-interlock*
	call.d %r10
	ld.w %r12, %r0			; *delay*
	;
	xld.w %r10, [%r0+CYCLE]		; CYCLE -= op->cycle
	xld.ub %r11, [%r2+5]
	sub %r10, %r11
	xld.w [%r0+CYCLE], %r10
	;
	popn %r2
	ret

;****************************************************************************
;
;****************************************************************************

#endif /*DMG_ASM*/
